MinguoEra (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: java.time.chrono, enum: MinguoEra
Keywords: java.time.chrono.MinguoEra class

# Enum Class MinguoEra

java.lang.Object
java.lang.Enum<MinguoEra>
java.time.chrono.MinguoEra

All Implemented Interfaces:
  `Serializable, Comparable<MinguoEra>, Constable, Era, TemporalAccessor, TemporalAdjuster`

public enum MinguoEra extends Enum<MinguoEra> implements Era
An era in the Minguo calendar system.

The Minguo calendar system has two eras. The current era, for years from 1 onwards, is known as the 'Republic of China' era. All previous years, zero or earlier in the proleptic count or one and greater in the year-of-era count, are part of the 'Before Republic of China' era.

Minguo years and eras
year-of-era | era | proleptic-year | ISO proleptic-year
--- | --- | --- | ---
2 | ROC | 2 | 1913
1 | ROC | 1 | 1912
1 | BEFORE_ROC | 0 | 1911
2 | BEFORE_ROC | -1 | 1910

Do not use `ordinal()` to obtain the numeric representation of `MinguoEra`. Use `getValue()` instead.

Implementation Requirements:
  This is an immutable and thread-safe enum.
Since:
  1.8

- ## Nested Class Summary

  ### Nested classes/interfaces declared in class Enum

  `Enum.EnumDesc<E>`
  Modifier and Type
  Class
  Description
  `static final class`
  `Enum.EnumDesc<E extends Enum<E>>`
  A nominal descriptor for an `enum` constant.

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `BEFORE_ROC`
  The singleton instance for the era before the current one, 'Before Republic of China Era', which has the numeric value 0.
  `ROC`
  The singleton instance for the current era, 'Republic of China Era', which has the numeric value 1.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getDisplayName(TextStyle style, Locale locale)`
  Gets the textual representation of this era.
  `int`
  `getValue()`
  Gets the numeric era `int` value.
  `static MinguoEra`
  `of(int minguoEra)`
  Obtains an instance of `MinguoEra` from an `int` value.
  `static MinguoEra`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static MinguoEra[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods declared in class Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`
  Modifier and Type
  Method
  Description
  `protected final Object`
  `clone()`
  Throws CloneNotSupportedException.
  `final int`
  `compareTo(MinguoEra o)`
  Compares this enum with the specified object for order.
  `final Optional<Enum.EnumDesc<MinguoEra>>`
  `describeConstable()`
  Returns an enum descriptor `EnumDesc` for this instance, if one can be constructed, or an empty `Optional` if one cannot be.
  `final boolean`
  `equals(Object other)`
  Returns true if the specified object is equal to this enum constant.
  `protected final void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization has been deprecated for removal.
  `final Class<MinguoEra>`
  `getDeclaringClass()`
  Returns the Class object corresponding to this enum constant's enum type.
  `final int`
  `hashCode()`
  Returns a hash code for this enum constant.
  `final String`
  `name()`
  Returns the name of this enum constant, exactly as declared in its enum declaration.
  `final int`
  `ordinal()`
  Returns the ordinal of this enumeration constant (its position in its enum declaration, where the initial constant is assigned an ordinal of zero).
  `String`
  `toString()`
  Returns the name of this enum constant, as contained in the declaration.
  `static <T extends Enum<T>>
  T`
  `valueOf(Class<T> enumClass, String name)`
  Returns the enum constant of the specified enum class with the specified name.

  ### Methods declared in class Object

  `getClass, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

  ### Methods declared in interface Era

  `adjustInto, get, getLong, isSupported, query, range`
  Modifier and Type
  Method
  Description
  `default Temporal`
  `adjustInto(Temporal temporal)`
  Adjusts the specified temporal object to have the same era as this object.
  `default int`
  `get(TemporalField field)`
  Gets the value of the specified field from this era as an `int`.
  `default long`
  `getLong(TemporalField field)`
  Gets the value of the specified field from this era as a `long`.
  `default boolean`
  `isSupported(TemporalField field)`
  Checks if the specified field is supported.
  `default <R> R`
  `query(TemporalQuery<R> query)`
  Queries this era using the specified query.
  `default ValueRange`
  `range(TemporalField field)`
  Gets the range of valid values for the specified field.

- ## Enum Constant Details

  - ### BEFORE_ROC

    public static final MinguoEra BEFORE_ROC
    The singleton instance for the era before the current one, 'Before Republic of China Era', which has the numeric value 0.

  - ### ROC

    public static final MinguoEra ROC
    The singleton instance for the current era, 'Republic of China Era', which has the numeric value 1.

- ## Method Details

  - ### values

    public static MinguoEra[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static MinguoEra valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### of

    public static MinguoEra of(int minguoEra)
    Obtains an instance of `MinguoEra` from an `int` value.

    `MinguoEra` is an enum representing the Minguo eras of BEFORE_ROC/ROC. This factory allows the enum to be obtained from the `int` value.

    Parameters:
      `minguoEra` - the BEFORE_ROC/ROC value to represent, from 0 (BEFORE_ROC) to 1 (ROC)
    Returns:
      the era singleton, not null
    Throws:
      `DateTimeException` - if the value is invalid

  - ### getValue

    public int getValue()
    Gets the numeric era `int` value.

    The era BEFORE_ROC has the value 0, while the era ROC has the value 1.

    Specified by:
      `getValue` in interface `Era`
    Returns:
      the era value, from 0 (BEFORE_ROC) to 1 (ROC)

  - ### getDisplayName

    public String getDisplayName(TextStyle style, Locale locale)
    Gets the textual representation of this era.

    This returns the textual name used to identify the era, suitable for presentation to the user. The parameters control the style of the returned text and the locale.

    If no textual mapping is found then the `numeric value` is returned.

    Specified by:
      `getDisplayName` in interface `Era`
    Parameters:
      `style` - the style of the text required, not null
      `locale` - the locale to use, not null
    Returns:
      the text value of the era, not null